//+------------------------------------------------------------------+
//|                           MA OsMAfilter Crossover Alert v1.2.mq4 |
//|     based upon:                           MA-Crossover_Alert.mq4 |
//|         Copyright  2005, Jason Robinson (jnrtrading)            |
//|                   http://www.jnrtading.co.uk                     |
//| Modified by Robert Hill to add LSMA and alert or send email      |
//| Added Global LastAlert to try to have alert only on new cross    |
//| but does not seem to work. So indicator does alert every bar     |
//+------------------------------------------------------------------+
//Alerts extended/osma-filter implemented by forexBaron.net 12.2013
/*
  +------------------------------------------------------------------+
  | Allows you to enter two ma periods and it will then show you at  |
  | Which point they crossed over. It is more usful on the shorter   |
  | periods that get obscured by the bars / candlesticks and when    |
  | the zoom level is out. Also allows you then to remove the  mas   |
  | from the chart. (emas are initially set at 5 and 20)             |
  +------------------------------------------------------------------+
*/   
#property copyright "Copyright  2005, Jason Robinson (jnrtrading), Force_Index-filter by forexBaron.net"
#property link      "http://forexBaron.net" //seems to be sold: "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_color2 Red

extern int FastMA_Mode = 1; //0=sma, 1=ema, 2=smma, 3=lwma, 4=lsma
extern int FastMA_Period =   1;
extern int FastPriceMode = 0;//0=close, 1=open, 2=high, 3=low, 4=median(high+low)/2, 5=typical(high+low+close)/3, 6=weighted(high+low+close+close)/4
extern int SlowMA_Mode = 1; //0=sma, 1=ema, 2=smma, 3=lwma, 4=lsma
extern int SlowMA_Period =   21;
extern int SlowPriceMode = 0;//0=close, 1=open, 2=high, 3=low, 4=median(high+low)/2, 5=typical(high+low+close)/3, 6=weighted(high+low+close+close)/4
//
//extern string oshi="if true, Force_Index.ex4 indicator must exist in the mt4/experts/indicators/-folder";//replaced by iForce_Index(...
extern bool UseForcefilter=true;
extern int ExtForcePeriod=2;
extern int ExtForceMAMethod=1;
extern int ExtForceAppliedPrice=0;

extern string ahi="*** ALERT SETTINGS:";
extern int  AlertCandle = 1;
extern bool PopupAlerts=true;
extern bool PushNotificationAlerts=false;
extern bool EmailAlerts=false;
extern bool SoundAlerts=false;
extern string SoundFileLong="alert.wav";
extern string SoundFileShort="alert2.wav";
string msg;
int lastAlert=3;

double CrossUp[];
double CrossDown[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY, 1);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexLabel(0,"CrossUP");
   SetIndexStyle(1, DRAW_ARROW, EMPTY, 1);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
   SetIndexLabel(1,"CrossDN");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| LSMA with PriceMode                                              |
//| PrMode  0=close, 1=open, 2=high, 3=low, 4=median(high+low)/2,    |
//| 5=typical(high+low+close)/3, 6=weighted(high+low+close+close)/4  |
//+------------------------------------------------------------------+

double LSMA(int Rperiod, int prMode, int shift)
{
   int i;
   double sum, pr;
   int length;
   double lengthvar;
   double tmp;
   double wt;

   length = Rperiod;
 
   sum = 0;
   for(i = length; i >= 1  ; i--)
   {
     lengthvar = length + 1;
     lengthvar /= 3;
     tmp = 0;
     switch (prMode)
     {
     case 0: pr = Close[length-i+shift];break;
     case 1: pr = Open[length-i+shift];break;
     case 2: pr = High[length-i+shift];break;
     case 3: pr = Low[length-i+shift];break;
     case 4: pr = (High[length-i+shift] + Low[length-i+shift])/2;break;
     case 5: pr = (High[length-i+shift] + Low[length-i+shift] + Close[length-i+shift])/3;break;
     case 6: pr = (High[length-i+shift] + Low[length-i+shift] + Close[length-i+shift] + Close[length-i+shift])/4;break;
     }
     tmp = ( i - lengthvar)*pr;
     sum+=tmp;
    }
    wt = sum*6/(length*(length+1));
    
    return(wt);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double tmp=0;
   double fastMAnow, slowMAnow, fastMAprevious, slowMAprevious;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   double Force=0.0;
   double Force1=0.0;
   
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      
      if (UseForcefilter) {
       Force=iForce(Symbol(),0,ExtForcePeriod,ExtForceMAMethod,ExtForceAppliedPrice,i);//iCustom(Symbol(),0,"Force",ForcePeriod,ForceMAMethod,ForceAppliedPrice,0,i);
       Force1=iForce(Symbol(),0,ExtForcePeriod,ExtForceMAMethod,ExtForceAppliedPrice,i+1);//iCustom(Symbol(),0,"Force",ForcePeriod,ForceMAMethod,ForceAppliedPrice,0,i+1);
      }
       
      if (FastMA_Mode == 4)
      {
         fastMAnow = LSMA(FastMA_Period, FastPriceMode, i);
         fastMAprevious = LSMA(FastMA_Period, FastPriceMode,  i+1);
         
      }
      else
      {
         fastMAnow = iMA(NULL, 0, FastMA_Period, 0, FastMA_Mode, FastPriceMode, i);
         fastMAprevious = iMA(NULL, 0, FastMA_Period, 0, FastMA_Mode, FastPriceMode, i+1);
      }

      if (SlowMA_Mode == 4)
      {
         slowMAnow = LSMA( SlowMA_Period, SlowPriceMode, i);
         slowMAprevious = LSMA( SlowMA_Period, SlowPriceMode, i+1);
      }
      else
      {
         slowMAnow = iMA(NULL, 0, SlowMA_Period, 0, SlowMA_Mode, SlowPriceMode, i);
         slowMAprevious = iMA(NULL, 0, SlowMA_Period, 0, SlowMA_Mode, SlowPriceMode, i+1);
      }
//---- 
      if (lastAlert!=2
      &&  (   (!UseForcefilter && fastMAnow > slowMAnow && fastMAprevious < slowMAprevious)||(UseForcefilter && fastMAnow > slowMAnow && fastMAprevious < slowMAprevious && Force<0.0) || (UseForcefilter && fastMAnow>slowMAnow && Force<0.0 && Force1>0.0) )
      )
      {
       lastAlert=2;
       CrossUp[i] = Low[i] - Range*0.75;
      }
      else if (lastAlert!=1 
           &&  (   (!UseForcefilter && fastMAnow < slowMAnow && fastMAprevious > slowMAprevious)||(UseForcefilter && fastMAnow < slowMAnow && fastMAprevious > slowMAprevious && Force>0.0) || (UseForcefilter && fastMAnow<slowMAnow && Force>0.0 && Force1<0.0) )
           )
           {
            lastAlert=1;
            CrossDown[i] = High[i] + Range*0.75;
           }
//----      
  if (CrossUp[AlertCandle]!=EMPTY_VALUE)  doAlerts("LONG CROSS",SoundFileLong);
  if (CrossDown[AlertCandle]!=EMPTY_VALUE)  doAlerts("SHORT CROSS",SoundFileShort);
   }

   return(0);
}

/////////////////////////////////////////////////////////////////////////////////////////
void doAlerts(string msg,string SoundFile) {
 static datetime lastAlertTime=0;
 if (lastAlertTime!=iTime(NULL,0,0)) { lastAlertTime=iTime(NULL,0,0);

 msg="MA Crossover Alerts on "+Symbol()+", period "+TFtoStr(Period())+": "+msg;
 string emailsubject="MT4 alert on acc. "+AccountNumber()+", "+WindowExpertName()+" - Alert on "+Symbol()+", period "+TFtoStr(Period());
  if (PopupAlerts) Alert(msg);
  if (EmailAlerts) SendMail(emailsubject,msg);
  if (PushNotificationAlerts) SendNotification(msg);
  if (SoundAlerts) PlaySound(SoundFile);

 }//if (lastAlertTime!=iTime(NULL,0,0)) {
 
}//void doAlerts(string msg,string SoundFile) {

string TFtoStr(int period) {
 switch(period) {
  case 1     : return("M1");  break;
  case 5     : return("M5");  break;
  case 15    : return("M15"); break;
  case 30    : return("M30"); break;
  case 60    : return("H1");  break;
  case 240   : return("H4");  break;
  case 1440  : return("D1");  break;
  case 10080 : return("W1");  break;
  case 43200 : return("MN1"); break;
  default    : return(DoubleToStr(period,0));
 }
 return("UNKNOWN");
}//string TFtoStr(int period) {
//////////////////////////////////////////////////////////////////////